﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace PixelCounter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnChooseColour_Click(object sender, EventArgs e)
        {
            DialogResult dr = colorDialog1.ShowDialog();
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                pbxColour.BackColor = colorDialog1.Color;
            }
        }

        private void btnColour2_Click(object sender, EventArgs e)
        {
            DialogResult dr = colorDialog2.ShowDialog();
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                pbxColour2.BackColor = colorDialog2.Color;
            }
        }

        private void btnColour3_Click(object sender, EventArgs e)
        {
            DialogResult dr = colorDialog3.ShowDialog();
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                pbxColour3.BackColor = colorDialog3.Color;
            }
        }


        private void btnChoosePic_Click(object sender, EventArgs e)
        {
            DialogResult dr = openFileDialog1.ShowDialog();

            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                txtPicturePath.Text = openFileDialog1.FileName;
                pbxPicture.Image = new Bitmap(openFileDialog1.FileName);
            }
        }


        private void SomeMethod(string imgPath, Color compareColor)
        {

            // http://stackoverflow.com/questions/6020406/travel-through-pixels-in-bmp
            Bitmap bmp = new Bitmap(imgPath);
            
            // Lock the bitmap's bits.  
            Rectangle rect = new Rectangle(0, 0, bmp.Width, bmp.Height);
            BitmapData bmpData = bmp.LockBits(rect, ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);

            // Get the address of the first line.
            IntPtr ptr = bmpData.Scan0;

            // Declare an array to hold the bytes of the bitmap.
            int bytes = bmpData.Stride * bmp.Height;
            byte[] rgbValues = new byte[bytes];
            byte[] r = new byte[bytes / 3];
            byte[] g = new byte[bytes / 3];
            byte[] b = new byte[bytes / 3];

            // Copy the RGB values into the array.
            Marshal.Copy(ptr, rgbValues, 0, bytes);

            int count = 0;
            int stride = bmpData.Stride;

            for (int column = 0; column < bmpData.Height; column++)
            {
                for (int row = 0; row < bmpData.Width; row++)
                {
                    b[count] = (byte)(rgbValues[(column * stride) + (row * 3)]);
                    g[count] = (byte)(rgbValues[(column * stride) + (row * 3) + 1]);
                    r[count++] = (byte)(rgbValues[(column * stride) + (row * 3) + 2]);
                }
            }

        }


        private string SomeOtherMethod(string imgPath, Color compareColor)
        {
            // http://stackoverflow.com/questions/6020406/travel-through-pixels-in-bmp
            Bitmap bmp = new Bitmap(imgPath);
            int count = 0;
            int total = 0;
            int intVariance = Convert.ToInt32(nudVariance.Value);

            for (int ii = 0; ii < bmp.Width; ii++)
            {
                for (int jj = 0; jj < bmp.Height; jj++)
                {
                    Color pixelColor = bmp.GetPixel(ii, jj);
                    
                    // do stuff with pixelColor
                    if ((pixelColor.R <= compareColor.R + intVariance) && (pixelColor.R >= compareColor.R - intVariance) && (pixelColor.G <= compareColor.G + intVariance) && (pixelColor.G >= compareColor.G - intVariance) && (pixelColor.B <= compareColor.B + intVariance) && (pixelColor.B >= compareColor.B - intVariance))
                    {
                        count++;
                    }
                    total++;
                }
            }

            decimal percent = (Convert.ToDecimal(count) / Convert.ToDecimal(total)) * 100;

            return "Counted " + count.ToString() + " pixels of " + total.ToString() + " (" + percent.ToString() + "%)";
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            txtColourCountOutput.Text = "";
            Application.DoEvents();
            txtColourCountOutput.Text  = "Colour 1: " + SomeOtherMethod(txtPicturePath.Text, pbxColour.BackColor) + "\r\n";
            Application.DoEvents();
            txtColourCountOutput.Text += "Colour 2: " + SomeOtherMethod(txtPicturePath.Text, pbxColour2.BackColor) + "\r\n";
            Application.DoEvents();
            txtColourCountOutput.Text += "Colour 3: " + SomeOtherMethod(txtPicturePath.Text, pbxColour3.BackColor) + "\r\n";
            Application.DoEvents();
        }



    }
}
